#!/bin/bash
# pacman-Shell is a bash gui for pacman
#
# Creation-Date: 2013-09-28
# Revision-Date: 2013-10-16
#
# Release: 1.7
#
# BULIN Claude
# http://www.xcfa.tuxfamily.org/
#
# Based on an idea of:
# http://alexiobash.com/yaourt-gui-a-bash-gui-per-yaourt-3/


###
# Set
###
TEXTDOMAINDIR=/usr/share/locale
TEXTDOMAIN=pacman-shell
VER=1.7
BLUE="\033[7;34m"
BLU="\033[1;34m"
RED="\033[1;31m"
LRED="\033[7;31m"
WHI="\033[1;37m"
NC="\033[0m"
YELLOW="\033[1;33m"
GREL="\033[7;32m"
GRE="\033[1;32m"
BoolQuit=0

###
# export for language translate
###
export TEXTDOMAINDIR=/usr/share/locale
export TEXTDOMAIN=pacman-shell

###
# pause
###
function pause() {
	echo -e "$GRE"
	echo -n "$(gettext 'Press ENTER to display the Menu') "
	while read -r -n 1 -s answer; do
		break
	done
	echo -e "$NC"

}

###
# get_key
###
function get_key() {
	echo -e "$YELLOW"
	echo -n "$(gettext 'Type a letter of command or [ Q/q ] to quit ...: ')"
	while read -r -n 1 -s answer; do
		if [[ $answer = [AaBbCcDdEeFfGgHhIiJjKkLlRrQq] ]]; then
			[[ $answer = [Aa] ]] && retval=0
			[[ $answer = [Bb] ]] && retval=1
			[[ $answer = [Cc] ]] && retval=2
			[[ $answer = [Dd] ]] && retval=3
			[[ $answer = [Ee] ]] && retval=4
			[[ $answer = [Ff] ]] && retval=5
			[[ $answer = [Gg] ]] && retval=6
			[[ $answer = [Hh] ]] && retval=7
			[[ $answer = [Ii] ]] && retval=8
			[[ $answer = [Jj] ]] && retval=9
			[[ $answer = [Kk] ]] && retval=10
			[[ $answer = [Ll] ]] && retval=11
			[[ $answer = [Rr] ]] && retval=12
			[[ $answer = [Qq] ]] && retval=13
			break
		fi
	done
	echo $answer # just a final linefeed, optics...
	echo -e "$NC"
	return $retval
}

###
# lock_file_pacman_exist
###
lock_file_pacman_exist () {
	if [ -f "/var/lib/pacman/db.lck" ]; then
		retval=0
	else
		retval=1
	fi
	return $retval
}

###
# Print name and version
###
PutName () {
	echo -e "$GREL                  PACMAN-SHELL $VER - A bash GUI for Pacman                 $NC"
}

###
# Start Script
###
gost () {
	clear
	kernel=`uname -r`
	cpu=`uname -m`
	Description=`lsb_release -d`
	release=`lsb_release -r`
	codename=`lsb_release -c`

	echo -e  "\E[01;32m"
	echo -e "     __  __             _                     "
	echo -e "    |  \/  |           (_)                    "$kernel
	echo -e "    | \  / | __ _ _ __  _  __ _ _ __ ___      "$cpu
	echo -e "    | |\/| |/ _\` | '_ \| |/ _\` | '__/ _ \   "
	echo -e "    | |  | | (_| | | | | | (_| | | | (_) |    "$Description
	echo -e "    |_|  |_|\__,_|_| |_| |\__,_|_|  \___/     "$release
	echo -e "                      _/ |                    "$codename
	echo -e "                     |__/                     "
	echo -e  "\e[00m"

	PutName
	echo -e " [$YELLOW A $NC] $(gettext 'Select mirroir')"
	echo ""
	echo -e " [$YELLOW B $NC] $(gettext 'Update from Manjaro deposits')"
	echo -e " [$YELLOW C $NC] $(gettext 'Update from AUR deposits')"
	echo ""
	echo -e " [$YELLOW D $NC] $(gettext 'Install a package from the repository')"
	echo -e " [$YELLOW E $NC] $(gettext 'Install a package from the repository while updating the system')"
	echo ""
	echo -e " [$YELLOW F $NC] $(gettext 'Deleting a package and its dependencies')"
	echo -e " [$YELLOW G $NC] $(gettext 'Deleting a package')"
	echo ""
	echo -e " [$YELLOW H $NC] $(gettext 'Searching a package in the system')"
	echo -e " [$YELLOW I $NC] $(gettext 'Searching a package in the repositories')"
	echo ""
	echo -e " [$YELLOW J $NC] $(gettext 'Information on a packet in the system')"
	echo -e " [$YELLOW K $NC] $(gettext 'Information on a package in the repositories')"
	echo ""
	echo -e " [$YELLOW L $NC] $(gettext 'List of packages (dependencies) are no longer required by the system')"

	lock_file_pacman_exist
	if [ $? == 0 ]; then
		echo ""
		echo -e " [$RED R $NC] $RED $(gettext 'Delete the lock file pacman')$NC"
	fi

	echo ""
	echo -e " [$YELLOW Q $NC] $(gettext 'Quit')"

	get_key
	case $? in

	### Selection mirroir
	### sudo pacman-mirrors -i
	0)
		echo -e ""
		echo -e "$GRE==> $(gettext 'Select mirroir')...$NC"
		echo -e "$YELLOW==> $(gettext 'COMMAND'): sudo pacman-mirrors -i $NC"
		sudo pacman-mirrors -i
		pause
		;;

	### Mise à jour complète Manjaro
	### sudo pacman-mirrors -g && sudo pacman -Syy && sudo pacman -Syu
	1)
		echo -e "$GRE==> $(gettext 'Updated from Manjaro deposits in progress')...$NC"
		echo -e "$YELLOW==> $(gettext 'COMMAND'): sudo pacman-mirrors -g  $NC "
		sudo pacman-mirrors -g
		echo -e "$YELLOW==> $(gettext 'COMMAND'): sudo pacman -Syy $NC "
		sudo pacman -Syy
		echo -e "$YELLOW==> $(gettext 'COMMAND'): sudo pacman -Syu $NC "
		sudo pacman -Syu
		pause
		;;

	### Mise à jour des dépôts AUR
	### yaourt -Syua
	2)
		echo -e ""
		echo -e "$GRE==> $(gettext 'Updated from AUR deposits in progress')...$NC"
		echo -e "$YELLOW==> $(gettext 'COMMAND'): yaourt -Syua $NC"
		yaourt -Syua
		pause
		;;
	### Installer un nouveau paquet depuis le depot
	### pacman -S paquet
	3)
		echo -e ""
		echo -e "$GRE==> $(gettext 'Install a package from the repository')...$NC"
		echo -e "$YELLOW==> $(gettext 'COMMAND'): sudo pacman -S <packet> $NC"
		echo -n "sudo pacman -S "
		answer=""
		read answer
		if [[ $answer != "" ]]; then
			sudo pacman -S $answer
			pause
		fi
		;;
	### Installer un nouveau paquet depuis le depot tout en mettant à jour le système
	### pacman -Syu paquet
	4)
		echo -e ""
		echo -e "$GRE==> $(gettext 'Install a package from the repository while updating the system')...$NC"
		echo -e "$YELLOW==> $(gettext 'COMMAND'): sudo pacman -Syu <packet> $NC"
		echo -n "sudo pacman -Syu "
		answer=""
		read answer
		if [[ $answer != "" ]]; then
			sudo pacman -Syu $answer
			pause
		fi
		;;
	### Supression d'un paquet et de ses dépendances
	### pacman -Rcs paquet
	5)
		echo -e ""
		echo -e "$GRE==> $(gettext 'Deleting a package and its dependencies')...$NC"
		echo -e "$YELLOW==> $(gettext 'COMMAND'): sudo pacman -Rcs <packet> $NC"
		echo -n "sudo pacman -Rcs "
		answer=""
		read answer
		if [[ $answer != "" ]]; then
			sudo pacman -Rcs $answer
			pause
		fi
		;;
	### Supression d'un paquet
	### pacman -R paquet
	6)
		echo -e ""
		echo -e "$GRE==> $(gettext 'Deleting a package')...$NC"
		echo -e "$YELLOW==> $(gettext 'COMMAND'): sudo pacman -R <packet> $NC"
		echo -n "sudo pacman -R "
		answer=""
		read answer
		if [[ $answer != "" ]]; then
			sudo pacman -R $answer
			pause
		fi
		;;
	### Recherche d'un paquet dans le système
	### pacman -Qs paquet
	7)
		echo -e ""
		echo -e "$GRE==> $(gettext 'Searching a package in the system')...$NC"
		echo -e "$YELLOW==> $(gettext 'COMMAND'): sudo pacman -Qs <packet> $NC"
		echo -n "sudo pacman -Qs "
		answer=""
		read answer
		if [[ $answer != "" ]]; then
			sudo pacman -Qs $answer
			pause
		fi
		;;
	### Recherche d'un paquet dans les dépôts
	### pacman -Ss paquet
	8)
		echo -e ""
		echo -e "$GRE==> $(gettext 'Searching a package in the repositories')...$NC"
		echo -e "$YELLOW==> $(gettext 'COMMAND'): pacman -Ss <packet> $NC"
		echo -n "pacman -Ss "
		answer=""
		read answer
		if [[ $answer != "" ]]; then
			pacman -Ss $answer
			pause
		fi
		;;
	### Information sur un paquet dans le système
	### pacman -Qi paquet
	9)
		echo -e ""
		echo -e "$GRE==> $(gettext 'Information on a packet in the system')...$NC"
		echo -e "$YELLOW==> $(gettext 'COMMAND'): pacman -Qi <packet> $NC"
		echo -n "pacman -Qi "
		answer=""
		read answer
		if [[ $answer != "" ]]; then
			pacman -Qi $answer
			pause
		fi
		;;
	### Information sur un paquet dans les dépôts
	### pacman -Si paquet
	10)
		echo -e ""
		echo -e "$GRE==> $(gettext 'Information on a package in the repositories')...$NC"
		echo -e "$YELLOW==> $(gettext 'COMMAND'): pacman -Si <packet> $NC"
		echo -n "pacman -Si "
		answer=""
		read answer
		if [[ $answer != "" ]]; then
			pacman -Si $answer
			pause
		fi
		;;
	### Liste des paquets (dépendances) n'étant plus requis par le système
	### pacman -Qdt
	11)
		echo -e ""
		echo -e "$GRE==> $(gettext 'List of packages (dependencies) are no longer required by the system')...$NC"
		echo -e "$YELLOW==> $(gettext 'COMMAND'): pacman -Qdt $NC"
		pacman -Qdt
		pause
		;;
	### Delete the lock file pacman
	### sudo rm -f /var/lib/pacman/db.lck
	12)
		lock_file_pacman_exist
		if [ $? == 0 ]; then
			echo -e ""
			echo -e "$GRE==> $(gettext 'Delete the lock file pacman')...$NC"
			echo -e "$RED==> $(gettext 'COMMAND'): sudo rm -f /var/lib/pacman/db.lck $NC"
			sudo rm -f /var/lib/pacman/db.lck
			echo -e "$RED==> Ok $NC"
		fi
		;;
	############
	### Quit ###
	############
	13)
		clear
		PutName
		BoolQuit=1
		;;
	#############
	### error ###
	#############
	*)
		echo -e ""
		echo -e "$RED$(gettext '!!! WARNING !!! Unknown command !!!') $NC"
		sleep 1
		;;
	esac
}

while [[ $BoolQuit -eq 0 ]]; do
	gost
done

### end script ###
